<template>
  <div class="pagination">
    <div class="field has-addons has-addons-right">
      <p class="control">
        <button class="button is-info" :disabled="isFirst" @click="currentPage -= 1">&lt;</button>
      </p>
      <p class="control">
        <input class="input page" type="number" min="1" v-model="currentPage" />
      </p>
      <p class="control">
        <button class="button is-info" :disabled="isLast" @click="currentPage += 1">&gt;</button>
      </p>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent, computed, ref, watch } from 'vue'

export default defineComponent({
  name: 'Pagination',
  props: {
    page: {
      type: Number,
      required: true,
    },
    size: {
      type: Number,
      required: true,
    },
    total: {
      type: Number,
      required: true,
    },
  },
  setup(props, context) {
    const currentPage = ref(1)
    const isFirst = computed(() => currentPage.value === 1)
    const isLast = computed(() => currentPage.value === props.total)

    watch(
      () => props.page,
      (newPage) => (currentPage.value = newPage),
      { immediate: true }
    )

    watch(currentPage, (newPage) => {
      if (newPage !== props.page) {
        context.emit('setPage', newPage)
      }
    })

    return { currentPage, isFirst, isLast }
  },
})
</script>

<style lang="scss" scoped>
.page {
  width: 5rem;
}
</style>
